Object.defineProperty(exports, "__esModule", { value: true });
exports.ChartContainer = exports.HeaderValue = exports.HeaderTitleLegend = exports.HeaderTitle = exports.ChartControls = exports.InlineContainer = exports.SectionValue = exports.SectionHeading = exports.SubHeading = void 0;
var tslib_1 = require("tslib");
var styled_1 = tslib_1.__importDefault(require("@emotion/styled"));
var space_1 = tslib_1.__importDefault(require("app/styles/space"));
exports.SubHeading = styled_1.default('h3')(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  font-size: ", ";\n  font-weight: normal;\n  color: ", ";\n  margin: 0;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n"], ["\n  font-size: ", ";\n  font-weight: normal;\n  color: ", ";\n  margin: 0;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n"])), function (p) { return p.theme.fontSizeLarge; }, function (p) { return p.theme.textColor; });
exports.SectionHeading = styled_1.default('h4')(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  display: inline-grid;\n  grid-auto-flow: column;\n  grid-gap: ", ";\n  align-items: center;\n  color: ", ";\n  font-size: ", ";\n  margin: ", " 0;\n"], ["\n  display: inline-grid;\n  grid-auto-flow: column;\n  grid-gap: ", ";\n  align-items: center;\n  color: ", ";\n  font-size: ", ";\n  margin: ", " 0;\n"])), space_1.default(1), function (p) { return p.theme.subText; }, function (p) { return p.theme.fontSizeMedium; }, space_1.default(1));
exports.SectionValue = styled_1.default('span')(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  color: ", ";\n  font-size: ", ";\n  margin-right: ", ";\n"], ["\n  color: ", ";\n  font-size: ", ";\n  margin-right: ", ";\n"])), function (p) { return p.theme.subText; }, function (p) { return p.theme.fontSizeMedium; }, space_1.default(1));
exports.InlineContainer = styled_1.default('div')(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n  display: grid;\n  align-items: center;\n\n  @media (min-width: ", ") {\n    grid-auto-flow: column;\n    grid-column-gap: ", ";\n  }\n"], ["\n  display: grid;\n  align-items: center;\n\n  @media (min-width: ", ") {\n    grid-auto-flow: column;\n    grid-column-gap: ", ";\n  }\n"])), function (p) { return p.theme.breakpoints[0]; }, space_1.default(1));
exports.ChartControls = styled_1.default('div')(templateObject_5 || (templateObject_5 = tslib_1.__makeTemplateObject(["\n  padding: ", " ", ";\n  border-top: 1px solid ", ";\n\n  @media (min-width: ", ") {\n    display: flex;\n    justify-content: space-between;\n    flex-wrap: wrap;\n  }\n"], ["\n  padding: ", " ", ";\n  border-top: 1px solid ", ";\n\n  @media (min-width: ", ") {\n    display: flex;\n    justify-content: space-between;\n    flex-wrap: wrap;\n  }\n"])), space_1.default(1), space_1.default(3), function (p) { return p.theme.border; }, function (p) { return p.theme.breakpoints[0]; });
// Header element for charts within panels.
exports.HeaderTitle = styled_1.default('div')(templateObject_6 || (templateObject_6 = tslib_1.__makeTemplateObject(["\n  display: inline-grid;\n  grid-auto-flow: column;\n  grid-gap: ", ";\n  font-size: ", ";\n  color: ", ";\n  align-items: center;\n"], ["\n  display: inline-grid;\n  grid-auto-flow: column;\n  grid-gap: ", ";\n  font-size: ", ";\n  color: ", ";\n  align-items: center;\n"])), space_1.default(1), function (p) { return p.theme.fontSizeLarge; }, function (p) { return p.theme.textColor; });
// Header element for charts within panels
// This header can be rendered while the chart is still loading
exports.HeaderTitleLegend = styled_1.default(exports.HeaderTitle)(templateObject_7 || (templateObject_7 = tslib_1.__makeTemplateObject(["\n  background-color: ", ";\n  border-bottom-right-radius: ", ";\n  position: absolute;\n  z-index: 1;\n"], ["\n  background-color: ", ";\n  border-bottom-right-radius: ", ";\n  position: absolute;\n  z-index: 1;\n"])), function (p) { return p.theme.background; }, function (p) { return p.theme.borderRadius; });
// Used for rendering total value of a chart right below the HeaderTitleLegend
exports.HeaderValue = styled_1.default('div')(templateObject_8 || (templateObject_8 = tslib_1.__makeTemplateObject(["\n  display: inline-grid;\n  grid-auto-flow: column;\n  grid-gap: ", ";\n  align-items: baseline;\n  background-color: ", ";\n  position: absolute;\n  top: 40px;\n  z-index: 1;\n  font-size: ", ";\n"], ["\n  display: inline-grid;\n  grid-auto-flow: column;\n  grid-gap: ", ";\n  align-items: baseline;\n  background-color: ", ";\n  position: absolute;\n  top: 40px;\n  z-index: 1;\n  font-size: ", ";\n"])), space_1.default(1), function (p) { return p.theme.background; }, function (p) { return p.theme.headerFontSize; });
exports.ChartContainer = styled_1.default('div')(templateObject_9 || (templateObject_9 = tslib_1.__makeTemplateObject(["\n  padding: ", " ", ";\n"], ["\n  padding: ", " ", ";\n"])), space_1.default(2), space_1.default(3));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9;
//# sourceMappingURL=styles.jsx.map