Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var loadingPanel_1 = tslib_1.__importDefault(require("app/components/charts/loadingPanel"));
var defaultProps = {
    height: '200px',
};
var TransitionChart = /** @class */ (function (_super) {
    tslib_1.__extends(TransitionChart, _super);
    function TransitionChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            prevReloading: _this.props.reloading,
            prevLoading: _this.props.loading,
            key: 1,
        };
        return _this;
    }
    TransitionChart.getDerivedStateFromProps = function (props, state) {
        // Transitions are controlled using variables called:
        // - loading and,
        // - reloading (also called pending in other apps)
        //
        // This component remounts the chart to ensure the stable transition
        // from one data set to the next.
        var prevReloading = state.prevReloading;
        var nextReloading = props.reloading;
        var prevLoading = state.prevLoading;
        var nextLoading = props.loading;
        // whenever loading changes, we explicitly remount the children by updating
        // the key prop; regardless of what state reloading is in
        if (prevLoading !== nextLoading) {
            return {
                prevReloading: nextReloading,
                prevLoading: nextLoading,
                key: state.key + 1,
            };
        }
        // invariant: prevLoading === nextLoading
        // if loading is true, and hasn't changed from the previous re-render,
        // do not remount the children.
        if (nextLoading) {
            return {
                prevReloading: nextReloading,
                prevLoading: nextLoading,
                key: state.key,
            };
        }
        // invariant: loading is false
        // whenever the chart is transitioning from the reloading (pending) state to a non-loading state,
        // remount the children
        if (prevReloading && !nextReloading) {
            return {
                prevReloading: nextReloading,
                prevLoading: nextLoading,
                key: state.key + 1,
            };
        }
        // do not remount the children in these remaining cases:
        // !prevReloading && !nextReloading (re-render with no prop change)
        // prevReloading && nextReloading (re-render with no prop change)
        // !prevReloading && nextReloading (from loaded to pending state)
        return {
            prevReloading: nextReloading,
            prevLoading: nextLoading,
            key: state.key,
        };
    };
    TransitionChart.prototype.render = function () {
        var _a = this.props, height = _a.height, loading = _a.loading, reloading = _a.reloading;
        if (loading && !reloading) {
            return <loadingPanel_1.default height={height} data-test-id="events-request-loading"/>;
        }
        // We make use of the key prop to explicitly remount the children
        // https://reactjs.org/docs/lists-and-keys.html#keys
        return <react_1.Fragment key={String(this.state.key)}>{this.props.children}</react_1.Fragment>;
    };
    TransitionChart.defaultProps = defaultProps;
    return TransitionChart;
}(react_1.Component));
exports.default = TransitionChart;
//# sourceMappingURL=transitionChart.jsx.map