Object.defineProperty(exports, "__esModule", { value: true });
exports.filterAliases = exports.releaseHealth = exports.performance = exports.tracing = exports.sourceMaps = exports.desktop = exports.serverless = exports.backend = exports.mobile = exports.frontend = void 0;
var tslib_1 = require("tslib");
var locale_1 = require("app/locale");
var popular = [
    'javascript',
    'javascript-react',
    'javascript-nextjs',
    'python-django',
    'python',
    'python-flask',
    'ruby-rails',
    'node-express',
    'php-laravel',
    'java',
    'java-spring-boot',
    'dotnet',
    'dotnet-aspnetcore',
    'csharp',
    'go',
    'php',
    'ruby',
    'node',
    'react-native',
    'javascript-angular',
    'javascript-vue',
    'android',
    'apple-ios',
    'flutter',
    'dart-flutter',
];
exports.frontend = [
    'dart',
    'javascript',
    'javascript-react',
    'javascript-angular',
    'javascript-angularjs',
    'javascript-backbone',
    'javascript-ember',
    'javascript-gatsby',
    'javascript-vue',
    'javascript-nextjs',
];
exports.mobile = [
    'android',
    'apple-ios',
    'cordova',
    'capacitor',
    'javascript-cordova',
    'javascript-capacitor',
    'react-native',
    'flutter',
    'dart-flutter',
    'unity',
    'dotnet-xamarin',
];
exports.backend = [
    'dotnet',
    'dotnet-aspnetcore',
    'dotnet-aspnet',
    'elixir',
    'go',
    'go-http',
    'java',
    'java-appengine',
    'java-log4j',
    'java-log4j2',
    'java-logback',
    'java-logging',
    'java-spring',
    'java-spring-boot',
    'native',
    'node',
    'node-express',
    'node-koa',
    'node-connect',
    'perl',
    'php',
    'php-laravel',
    'php-monolog',
    'php-symfony2',
    'python',
    'python-django',
    'python-flask',
    'python-sanic',
    'python-celery',
    'python-bottle',
    'python-pylons',
    'python-pyramid',
    'python-tornado',
    'python-rq',
    'ruby',
    'ruby-rails',
    'ruby-rack',
    'rust',
];
exports.serverless = [
    'python-awslambda',
    'python-azurefunctions',
    'python-gcpfunctions',
    'node-awslambda',
    'node-azurefunctions',
    'node-gcpfunctions',
    'dotnet-awslambda',
];
exports.desktop = [
    'apple-macos',
    'dotnet',
    'dotnet-winforms',
    'dotnet-wpf',
    'java',
    'electron',
    'javascript-electron',
    'native',
    'native-crashpad',
    'native-breakpad',
    'native-minidump',
    'native-qt',
    'minidump',
    'unity',
];
var categoryList = [
    { id: 'popular', name: locale_1.t('Popular'), platforms: popular },
    { id: 'browser', name: locale_1.t('Browser'), platforms: exports.frontend },
    { id: 'server', name: locale_1.t('Server'), platforms: exports.backend },
    { id: 'mobile', name: locale_1.t('Mobile'), platforms: exports.mobile },
    { id: 'desktop', name: locale_1.t('Desktop'), platforms: exports.desktop },
    { id: 'serverless', name: locale_1.t('Serverless'), platforms: exports.serverless },
];
exports.sourceMaps = tslib_1.__spreadArray(tslib_1.__spreadArray([], tslib_1.__read(exports.frontend)), [
    'react-native',
    'cordova',
    'electron',
]);
exports.tracing = ['python-tracing', 'node-tracing'];
exports.performance = [
    'javascript',
    'javascript-ember',
    'javascript-react',
    'javascript-vue',
    'php',
    'php-laravel',
    'python',
    'python-django',
    'python-flask',
    'python-sanic',
    'python-celery',
    'python-bottle',
    'python-pylons',
    'python-pyramid',
    'python-tornado',
    'python-rq',
    'node',
    'node-express',
    'node-koa',
    'node-connect',
];
exports.releaseHealth = [
    // frontend
    'javascript',
    'javascript-react',
    'javascript-angular',
    'javascript-angularjs',
    'javascript-backbone',
    'javascript-ember',
    'javascript-gatsby',
    'javascript-vue',
    'javascript-nextjs',
    // mobile
    'android',
    'apple-ios',
    'cordova',
    'javascript-cordova',
    'react-native',
    'flutter',
    'dart-flutter',
    // backend
    'native',
    'node',
    'node-express',
    'node-koa',
    'node-connect',
    'python',
    'python-django',
    'python-flask',
    'python-sanic',
    'python-celery',
    'python-bottle',
    'python-pylons',
    'python-pyramid',
    'python-tornado',
    'python-rq',
    'rust',
    // serverless
    // desktop
    'apple-macos',
    'native',
    'native-crashpad',
    'native-breakpad',
    'native-qt',
];
/**
 * Additional aliases used for filtering in the platform picker
 */
exports.filterAliases = {
    native: ['cpp', 'c++'],
};
exports.default = categoryList;
//# sourceMappingURL=platformCategories.jsx.map