Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_router_1 = require("react-router");
var resultGrid_1 = tslib_1.__importDefault(require("app/components/resultGrid"));
var locale_1 = require("app/locale");
var getRow = function (row) { return [
    <td key={row.id}>
    <strong>
      <react_router_1.Link to={"/" + row.slug + "/"}>{row.name}</react_router_1.Link>
    </strong>
    <br />
    <small>{row.slug}</small>
  </td>,
]; };
var AdminOrganizations = function (props) { return (<div>
    <h3>{locale_1.t('Organizations')}</h3>
    <resultGrid_1.default path="/manage/organizations/" endpoint="/organizations/?show=all" method="GET" columns={[<th key="column-org">Organization</th>]} columnsForRow={getRow} hasSearch sortOptions={[
        ['date', 'Date Joined'],
        ['members', 'Members'],
        ['events', 'Events'],
        ['projects', 'Projects'],
        ['employees', 'Employees'],
    ]} defaultSort="date" {...props}/>
  </div>); };
exports.default = AdminOrganizations;
//# sourceMappingURL=adminOrganizations.jsx.map